#!/bin/sh

# trap ^C
trap killpvs 2
TTY=`tty`

killpvs() {
  killall pvs-allegro5.0
  exit 1
}

typecheck() {
  echo "Typechecking context $context... ===================================="
  (
    cd $context || exit 1
    [ -f Makefile ] && gmake
    /usr/local/pvs/pvs -redhat 5 -emacs xemacs -batch -q -v 1 -l prove.el |
    tee $TTY |
    while read line ; do
   #echo $line
      case $line in
      *Leaving*)
     ## wait for pvs to exit
        echo "Waiting"
	sleep 30
	kill ` ps -uxwww | grep "xemacs -batch" | awk '{ print $2 }' `
	exit ;;
      esac
    done
  )
}

if [ $# -gt 0 ] ; then
  for context in $@ ; do typecheck $context ; done
else
  for context in lib basics ieee adder hw # mul_div
  do typecheck $context ; done
fi
